local T, auto_scan_inform, clean_scan_state = ...

local out_of_range_distance = 9999

local function is_roid_scanned(systemID, sectorID, roidID)
	return T.GetData(systemID, sectorID)[roidID] and true or false
end

function T.Scan.GetScannerRange()
-- TODO Fix stupid code in here
	local default_range = -1
	T.Scan.range = default_range
	for i = 1, GetActiveShipNumAddonPorts() or 0 - 1 do
		local itemID = GetActiveShipItemIDAtPort(i)
		local item_name = GetInventoryItemName(itemID) or ""

		if (item_name:match("Mineral Scanner")) then
			local desc = GetInventoryItemLongDesc(itemID)
			T.Scan.range = tonumber(desc:match("Range: (%d+)")) or default_range
			break
		end
	end

	if (T.Scan.range == default_range) then
		T.Scan.range = T.ShipsWithMineralScanners[GetActiveShipName()] or default_range
	end
end

function T.Scan.GetSectorNodeID()
	if (T.CurrentSectorNodeID) then return T.CurrentSectorNodeID end

	local orig_nodeid, orig_targetid = radar.GetRadarSelectionID()
	local start_ningAuto = T.Scan.ningAuto

	T.Scan.ningAuto = true -- Only needed because TargetNextClosestRoid won't work without it.
	if (T.Scan.Lock()) then
		T.CurrentSectorNodeID = T.Scan.TargetNextClosestRoid(true, true)
	else
		T.CurrentSectorNodeID = T.Scan.LockFunction(T.Scan.TargetNextClosestRoid, true, true)
	end
	T.Scan.ningAuto = start_ningAuto

	T.Scan.LockFunction(radar.SetRadarSelection, orig_nodeid, orig_targetid)
	return T.CurrentSectorNodeID
end

function T.Scan.Lock(state)
	if (state == nil) then return T.Scan.lock end

	T.Scan.lock = state
	if (isdeclared("targetless") and targetless) then
		targetless.api.radarlock = state
		targetless.var.lock = state
		targetless.var.scanlock = state
    end
    if (isdeclared("cargolist")) then
    end
    if (isdeclared("PR")) then
	end
end

function T.Scan.LockFunction(func, ...)
	-- active lock detection necessary to prevent the locks being lifted before a scan is complete.
	-- Take other measures to execute a function inside of a locked function
	if (T.Scan.Lock()) then return end
	T.Scan.Lock(true)
	return func(...), T.Scan.Lock(false)
end

local function autoscan_info(state, num_scanned, est_total, good_scan)
	print(string.format("%sAuto-scan is now %s%s.\127o", "\127FFFFFF", state and "\12700FF00" or "\127FF0000", state and "ON" or "OFF"))

	if (state) then
		if (good_scan) then
			HUD:PrintSecondaryMsg(num_scanned.." of "..est_total.." scanned.")
		end
		HUD.notify_text.title = "Auto-Scan in Progress"
		FadeControl(HUD.notify_text, 0, 1, 1)
	else
		-- Hide the "Auto-Scan in Progress" message
		FadeControl(HUD.notify_text, 0.5, 1, 0)
	end
end

function T.Scan.AutoScanStartStop(state)
	local toggling = T.Scan.ningAuto ~= (state or false)
	if (state ~= nil) then
		T.Scan.ningAuto = state
	else
		T.Scan.ningAuto = not T.Scan.ningAuto
	end

	if (T.Scan.ningAuto) then
		local all_scanned, num_scanned, est_total = T.RoidsScanned()
		if (all_scanned and est_total ~= 0) then
			print("\127FFFFFFAll asteroids have been scanned.\127o")
			T.Scan.ningAuto = false
		else
			if (T.Scan.GetSectorNodeID()) then
				-- If there's a bad initial scan, then we don't want to double-print the number of roids scanned
				autoscan_info(T.Scan.ningAuto, num_scanned, est_total, T.Scan.LockFunction(T.Scan.TargetNextClosestRoid, true))
			else
				T.Scan.ningAuto = false
				HUD:PrintSecondaryMsg("Unable to identify the sector.  No asteroids detected within radar range.")
				HUD:PrintSecondaryMsg("Auto-scan deactivated.")
			end
		end

	else
		if (toggling) then
			autoscan_info(T.Scan.ningAuto)
		end
	end
end

function T.Scan.PingTarget()
	-- ping_timer needs to be killed when the target is scanned or when the target changes
	local target_dist = GetTargetDistance() or out_of_range_distance
	if (target_dist <= T.Scan.range) then
		T.Scan.ReTarget()
	elseif (T.Scan.seek_mode == 1) then -- Continuous scan
		T.Scan.ping_timer:SetTimeout(1000, function() T.Scan.LockFunction(T.Scan.TargetNextClosestRoid, true) end)
	else
		T.Scan.ping_timer:SetTimeout(1000, function() T.Scan.LockFunction(T.Scan.PingTarget) end)
	end
end

function T.Scan.ReTarget()
	-- retarget roid
	local orig_nodeID, orig_targetID = radar.GetRadarSelectionID()
	gkinterface.GKProcessCommand("RadarNone")
	T.Scan.timer:SetTimeout(1, function() radar.SetRadarSelection(orig_nodeID, orig_targetID) end)
end

local roid_list = {}
function T.Scan.TargetNextClosestRoid(restart, get_nodeID)
	if (not T.Scan.ningAuto) then return false end -- Don't run if the proper initialization hasn't been done
	if (not get_nodeID and not T.Scan.GetSectorNodeID()) then return false end-- don't ScanLock here.  It's already inside of a ScanLock
	if (restart) then
		gkinterface.GKProcessCommand("RadarNone")
	end

	if (restart or T.Scan.seek_mode ~= 2 or os.time() - (roid_list.last_scan or 0) > 10) then
		-- Retain the roid list if using Single Sweep.
		roid_list = {}
	end

	local orig_nodeID, orig_targetID = radar.GetRadarSelectionID()
	local sector_data = T.GetData(GetCurrentSystemid(), GetCurrentSectorid())

	local target_dist = out_of_range_distance -- initialize the distance just in case roid_list is empty

	if (not next(roid_list)) then
		if (T.Scan.seek_mode < 3) then -- A complete scan to find the closest roid, instead of targeting the first in rangeroid
			repeat
				gkinterface.GKProcessCommand("RadarNext")
				local cur_nodeID, cur_targetID = radar.GetRadarSelectionID()

				if (get_nodeID and cur_nodeID == nil) then
					-- Can't find a roid in range to get the nodeid
					return false
				end

				if (T.IsAsteroid()) then
					if (get_nodeID) then
						return cur_nodeID
					elseif (not sector_data[cur_targetID]) then
						target_dist = GetTargetDistance() or out_of_range_distance
						-- Some targetable roids may present as having a distance of zero when they're a long distance away.
						-- Treat them as being out of range.
						if (target_dist < 1) then target_dist = out_of_range_distance end
						table.insert(roid_list, {cur_targetID, target_dist})
					end
				end
			until cur_targetID == orig_targetID

		else -- target the first roid in scan range
			-- scan all roids until one in scan range is found.  store all roids and distances for later use
			while target_dist > T.Scan.range do
				gkinterface.GKProcessCommand("RadarNext")
				local cur_nodeID, cur_targetID = radar.GetRadarSelectionID()
				if (get_nodeID and cur_nodeID == nil) then return end
				if (cur_targetID == orig_targetID) then break end -- we've come full circle.  Get out of here.

				if (T.IsAsteroid()) then
					if (get_nodeID) then
						return cur_nodeID
					elseif (not sector_data[cur_targetID]) then
						target_dist = GetTargetDistance() or out_of_range_distance
						-- Some targetable roids may present as having a distance of zero when they're a long distance away.
						-- Treat them as being out of range.
						if (target_dist < 1) then target_dist = out_of_range_distance end
						table.insert(roid_list, {cur_targetID, target_dist})
					end
				end
			end
		end
		roid_list.last_scan = os.time()
	end
	-- If no unscanned roids are in range, then stop
	if (#roid_list == 0) then
		local all_scanned, num_scanned, est_total = T.RoidsScanned()
		if (all_scanned) then
			print("\127FFFFFFAll asteroids have been scanned.\127o")
			T.Scan.AutoScanStartStop()
		else
			HUD:PrintSecondaryMsg("No unscanned asteroids currently in range.")
			HUD:PrintSecondaryMsg(num_scanned.." of "..est_total.." scanned.")
			gkinterface.GKProcessCommand("RadarNone")
			T.Scan.timer:SetTimeout(T.Scan.interval, function() T.Scan.LockFunction(T.Scan.TargetNextClosestRoid, true) end)
		end
		return false
	end

	-- sort the list even if there's a target in range.  The list will be used again on the next run.
	table.sort(roid_list, function(a, b) return a[2] < b[2] end)
	target_dist = roid_list[1][2]

	-- if the last roid was out of scan range, retarget the closest observed roid
	if (tonumber(target_dist) > T.Scan.range or T.Scan.seek_mode < 3) then
			radar.SetRadarSelection(T.Scan.GetSectorNodeID(), roid_list[1][1])
			table.remove(roid_list, 1)
	end

	T.Scan.PingTarget()

	return true
end
